Index: plugins/importExport/index.php
===================================================================
--- plugins/importExport/index.php	(revision 696)
+++ plugins/importExport/index.php	(revision 840)
@@ -2,7 +2,7 @@
 # -- BEGIN LICENSE BLOCK ---------------------------------------
 #
-# This file is part of Dotclear 2.
+# This file is part of importExport, a plugin for DotClear2.
 #
-# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2012 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -12,19 +12,21 @@
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
 
-require dirname(__FILE__).'/inc/class.dc.ieModule.php';
+function listImportExportModules($core,$modules)
+{
+	$res = '';
+	foreach ($modules as $id)
+	{
+		$o = new $id($core);
+		
+		$res .= 
+		'<dt><a href="'.$o->getURL(true).'">'.html::escapeHTML($o->name).'</a></dt>'.
+		'<dd>'.html::escapeHTML($o->description).'</dd>';
+		
+		unset($o);
+	}
+	return '<dl class="modules">'.$res.'</dl>';
+}
 
-$modules = new ArrayObject();
-$modules['i'] = new ArrayObject(array(
-	'dcImportFlat' => dirname(__FILE__).'/inc/class.dc.import.flat.php',
-	'dcImportFeed' => dirname(__FILE__).'/inc/class.dc.import.feed.php'
-));
-$modules['e'] = new ArrayObject(array(
-	'dcExportFlat' => dirname(__FILE__).'/inc/class.dc.export.flat.php'
-));
-
-if ($core->auth->isSuperAdmin()) {
-	$modules['i']['dcImportDC1']  = dirname(__FILE__).'/inc/class.dc.import.dc1.php';
-	$modules['i']['dcImportWP']  = dirname(__FILE__).'/inc/class.dc.import.wp.php';
-}
+$modules = new ArrayObject(array('import' => array(),'export' => array()));
 
 # --BEHAVIOR-- importExportModules
@@ -32,112 +34,62 @@
 
 $type = null;
-if (!empty($_REQUEST['t']) && ($_REQUEST['t'] == 'e' || $_REQUEST['t'] == 'i')) {
-	$type = $_REQUEST['t'];
+if (!empty($_REQUEST['type'])  && in_array($_REQUEST['type'],array('export','import'))) {
+	$type = $_REQUEST['type'];
 }
 
-$current_module = null;
-if ($type && !empty($_REQUEST['f'])) {
-	if (isset($modules[$type][$_REQUEST['f']])) {
-		require_once $modules[$type][$_REQUEST['f']];
-		$current_module = new $_REQUEST['f']($core);
-		$current_module->init();
+$module = null;
+if ($type && !empty($_REQUEST['module'])) {
+
+	if (isset($modules[$type]) && in_array($_REQUEST['module'],$modules[$type])) {
+	
+		$module = new $_REQUEST['module']($core);
+		$module->init();
 	}
 }
 
-if ($type && $current_module !== null && !empty($_REQUEST['do']))
+if ($type && $module !== null && !empty($_REQUEST['do']))
 {
 	try {
-		$current_module->process($_REQUEST['do']);
+		$module->process($_REQUEST['do']);
 	} catch (Exception $e) {
 		$core->error->add($e->getMessage());
 	}
 }
-?>
+
+$title = __('Import/Export');
+
+echo '
 <html>
 <head>
-	<title><?php echo __('Import/Export'); ?></title>
-	<style type="text/css">
-	dl.modules dt {
-		font-weight: bold;
-		font-size: 1.1em;
-		margin: 1em 0 0 0;
-	}
-	dl.modules dd {
-		margin: 0 0 1.5em 0;
-	}
-	div.ie-progress {
-		background: #eee;
-		margin: 1em 0;
-	}
-	div.ie-progress div {
-		height: 10px;
-		width: 0;
-		font-size: 0.8em;
-		line-height: 1em;
-		height: 1em;
-		padding: 2px 0;
-		text-align: right;
-		background: green url(index.php?pf=importExport/progress.png) repeat-x top left;
-		color: white;
-		font-weight: bold;
-		-moz-border-radius: 2px;
-	}
-	</style>
-	<script type="text/javascript" src="index.php?pf=importExport/script.js"></script>
+	<title>'.$title.'</title>
+	<link rel="stylesheet" type="text/css" href="index.php?pf=importExport/style.css" />
+	'.dcPage::jsLoad('index.php?pf=importExport/js/script.js').'
 	<script type="text/javascript">
 	//<![CDATA[
-	dotclear.msg.please_wait = '<?php echo html::escapeJS(__("Please wait...")); ?>';
+	'.dcPage::jsVar('dotclear.msg.please_wait',__('Please wait...')).'
 	//]]>
 	</script>
 </head>
-<body>
+<body>';
 
-<?php
-if ($type && $current_module !== null)
-{
-	echo '<h2><a href="'.$p_url.'">'.__('Import/Export').'</a>'.
-	' &rsaquo; <span class="page-title">'.html::escapeHTML($current_module->name).'</span></h2>';
+if ($type && $module !== null) {
+	echo
+	'<h2><a href="'.$p_url.'">'.$title.'</a>'.
+	' &rsaquo; <span class="page-title">'.html::escapeHTML($module->name).'</span></h2>'.
+	'<div id="ie-gui">';
 	
-	echo '<div id="ie-gui">';
-	$current_module->gui();
+	$module->gui();
+	
 	echo '</div>';
 }
-else
-{
-	echo '<h2 class="page-title">'.__('Import/Export').'</h2>';
-	echo '<h3>'.__('Import').'</h3>';
-	
-	echo '<dl class="modules">';
-	foreach ($modules['i'] as $k => $v)
-	{
-		require_once $v;
-		$o = new $k($core);
-		
-		echo 
-		'<dt><a href="'.$o->getURL(true).'">'.html::escapeHTML($o->name).'</a></dt>'.
-		'<dd>'.html::escapeHTML($o->description).'</dd>';
-		
-		unset($o);
-	}
-	echo '</dl>';
-	
-	echo '<h3>'.__('Export').'</h3>';
-	
-	echo '<dl class="modules">';
-	foreach ($modules['e'] as $k => $v)
-	{
-		require_once $v;
-		$o = new $k($core);
-		
-		echo 
-		'<dt><a href="'.$o->getURL(true).'">'.html::escapeHTML($o->name).'</a></dt>'.
-		'<dd>'.html::escapeHTML($o->description).'</dd>';
-		
-		unset($o);
-	}
-	echo '</dl>';
+else {
+	echo
+	'<h2 class="page-title">'.$title.'</h2>'.
+	'<h3>'.__('Import').'</h3>'.listImportExportModules($core,$modules['import']).
+	'<h3>'.__('Export').'</h3>'.listImportExportModules($core,$modules['export']);
 }
+
+echo '
+</body>
+</html>';
 ?>
-
-</body>
-</html>
Index: plugins/importExport/js/script.js
===================================================================
--- plugins/importExport/js/script.js	(revision 840)
+++ plugins/importExport/js/script.js	(revision 840)
@@ -0,0 +1,3 @@
+
+$(function(){if($('*.error').length>0){return;}
+$('#ie-gui form[method=post]:has(input[type=hidden][name=autosubmit])').each(function(){$('input[type=submit]',this).remove();$(this).after('<p style="font-size:2em;text-align:center">'+dotclear.msg.please_wait+'</p>');$(this).submit();});});
Index: plugins/pages/_prepend.php
===================================================================
--- plugins/pages/_prepend.php	(revision 776)
+++ plugins/pages/_prepend.php	(revision 857)
@@ -12,4 +12,6 @@
 if (!defined('DC_RC_PATH')) { return; }
 
+global $core;
+
 $core->url->register('pages','pages','^pages/(.+)$',array('urlPages','pages'));
 $core->url->register('pagespreview','pagespreview','^pagespreview/(.+)$',array('urlPages','pagespreview'));
Index: plugins/pages/list.php
===================================================================
--- plugins/pages/list.php	(revision 884)
+++ plugins/pages/list.php	(revision 578)
@@ -11,70 +11,55 @@
 # -- END LICENSE BLOCK -----------------------------------------
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
-
 dcPage::check('pages,contentadmin');
 
-class adminPageList extends adminItemsList
-{
-	public function setColumns()
+/* Pager class
+-------------------------------------------------------- */
+class adminPageList extends adminGenericList
+{
+	public function display($page,$nb_per_page,$enclose_block='')
 	{
-		$this->addColumn('title','post_title',__('Title'),array('adminPostList','getTitle'),array('class' => array('maximal')),true,true,false);
-		$this->addColumn('date','post_dt',__('Date'),array('adminPostList','getDate'));
-		$this->addColumn('datetime','post_dt',__('Date and time'),array('adminPostList','getDateTime'));
-		$this->addColumn('author','user_id',__('Author'),array('adminPostList','getAuthor'));
-		$this->addColumn('comments','nb_comment',__('Comments'),array('adminPostList','getComments'));
-		$this->addColumn('trackbacks','nb_trackback',__('Trackbacks'),array('adminPostList','getTrackbacks'));
-		$this->addColumn('status','post_status',__('Status'),array('adminPostList','getStatus'));
-		$this->default_sortby = 'datetime';
-		$this->default_order = 'desc';
-
+		if ($this->rs->isEmpty())
+		{
+			echo '<p><strong>'.__('No page').'</strong></p>';
+		}
+		else
+		{
+			$pager = new pager($page,$this->rs_count,$nb_per_page,10);
+			$pager->html_prev = $this->html_prev;
+			$pager->html_next = $this->html_next;
+			$pager->var_page = 'page';
+			
+			$html_block =
+			'<table class="clear"><tr>'.
+			'<th colspan="2">'.__('Title').'</th>'.
+			'<th>'.__('Date').'</th>'.
+			'<th>'.__('Author').'</th>'.
+			'<th>'.__('Comments').'</th>'.
+			'<th>'.__('Trackbacks').'</th>'.
+			'<th>'.__('Status').'</th>'.
+			'</tr>%s</table>';
+			
+			if ($enclose_block) {
+				$html_block = sprintf($enclose_block,$html_block);
+			}
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+			
+			$blocks = explode('%s',$html_block);
+			
+			echo $blocks[0];
+			
+			while ($this->rs->fetch())
+			{
+				echo $this->postLine();
+			}
+			
+			echo $blocks[1];
+			
+			echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
+		}
 	}
 	
-	protected function getDefaultCaption()
-	{
-		return __('Pages list');
-	}
-	
-	protected function getDefaultLine()
-	{
-		return
-		'<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
-		' id="p'.$this->rs->post_id.'">%s</tr>';
-	}
-	
-	protected function getTitle()
-	{
-		return
-		'<th scope="row" class="maximal">'.
-		form::checkbox(array('entries[]'),$this->rs->post_id,'','','',!$this->rs->isEditable()).'&nbsp;'.
-		'<a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
-		html::escapeHTML($this->rs->post_title).'</a></th>';
-	}
-	
-	protected function getDate()
-	{
-		return '<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d'),$this->rs->post_dt).'</td>';
-	}
-	
-	protected function getDateTime()
-	{
-		return '<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>';
-	}
-	
-	protected function getAuthor()
-	{
-		return '<td class="nowrap">'.$this->rs->user_id.'</td>';
-	}
-	
-	protected function getComments()
-	{
-		return '<td class="nowrap">'.$this->rs->nb_comment.'</td>';
-	}
-	
-	protected function getTrackbacks()
-	{
-		return '<td class="nowrap">'.$this->rs->nb_trackback.'</td>';
-	}
-	
-	protected function getStatus()
+	private function postLine()
 	{
 		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
@@ -99,4 +84,9 @@
 		}
 		
+		$selected = '';
+		if ($this->rs->post_selected) {
+			$selected = sprintf($img,__('selected'),'selected.png');
+		}
+		
 		$attach = '';
 		$nb_media = $this->rs->countMedia();
@@ -106,61 +96,47 @@
 		}
 		
-		return '<td class="nowrap status">'.$img_status.' '.$protected.' '.$attach.'</td>';
+		$res = '<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
+		' id="p'.$this->rs->post_id.'">';
+		
+		$res .=
+		'<td class="nowrap">'.
+		form::checkbox(array('entries[]'),$this->rs->post_id,'','','',!$this->rs->isEditable(),'title="'.__('select this page').'"').'</td>'.
+		'<td class="maximal"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
+		html::escapeHTML($this->rs->post_title).'</a></td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
+		
+		'<td class="nowrap">'.$this->rs->user_id.'</td>'.
+		'<td class="nowrap">'.$this->rs->nb_comment.'</td>'.
+		'<td class="nowrap">'.$this->rs->nb_trackback.'</td>'.
+		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
+		'</tr>';
+		
+		return $res;
 	}
 }
 
-
-# Getting authors
+/* Getting pages
+-------------------------------------------------------- */
+$params = array(
+	'post_type' => 'page'
+);
+
+$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
+$nb_per_page =  30;
+
+if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
+	$nb_per_page = (integer) $_GET['nb'];
+}
+
+$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
+$params['no_content'] = true;
+$params['order'] = 'post_position ASC, post_title ASC';
+
 try {
-	$users = $core->blog->getPostsUsers('page');
+	$pages = $core->blog->getPosts($params);
+	$counter = $core->blog->getPosts($params,true);
+	$post_list = new adminPageList($core,$pages,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
-}
-
-# Getting dates
-try {
-	$dates = $core->blog->getDates(array('type'=>'month','post_type'=>'page'));
-} catch (Exception $e) {
-	$core->error->add($e->getMessage());
-}
-
-# Getting langs
-try {
-	$langs = $core->blog->getLangs(array('post_type'=>'page'));
-} catch (Exception $e) {
-	$core->error->add($e->getMessage());
-}
-
-# Creating filter combo boxes
-if (!$core->error->flag())
-{
-	# Filter form we'll put in html_block
-	$users_combo = array();
-	while ($users->fetch())
-	{
-		$user_cn = dcUtils::getUserCN($users->user_id,$users->user_name,
-		$users->user_firstname,$users->user_displayname);
-		
-		if ($user_cn != $users->user_id) {
-			$user_cn .= ' ('.$users->user_id.')';
-		}
-		
-		$users_combo[$user_cn] = $users->user_id; 
-	}
-	
-	$status_combo = array(
-	);
-	foreach ($core->blog->getAllPostStatus() as $k => $v) {
-		$status_combo[$v] = (string) $k;
-	}
-	
-	# Months array
-	while ($dates->fetch()) {
-		$dt_m_combo[dt::str('%B %Y',$dates->ts())] = $dates->year().$dates->month();
-	}
-	
-	while ($langs->fetch()) {
-		$lang_combo[$langs->post_lang] = $langs->post_lang;
-	}
 }
 
@@ -169,76 +145,19 @@
 if ($core->auth->check('publish,contentadmin',$core->blog->id))
 {
-	$combo_action[__('Status')] = array(
-		__('Publish') => 'publish',
-		__('Unpublish') => 'unpublish',
-		__('Schedule') => 'schedule',
-		__('Mark as pending') => 'pending'
-	);
-}
-if ($core->auth->check('admin',$core->blog->id))
-{
-	$combo_action[__('Change')] = array(__('Change author') => 'author');
+	$combo_action[__('publish')] = 'publish';
+	$combo_action[__('unpublish')] = 'unpublish';
+	$combo_action[__('schedule')] = 'schedule';
+	$combo_action[__('mark as pending')] = 'pending';
+}
+if ($core->auth->check('admin',$core->blog->id)) {
+	$combo_action[__('change author')] = 'author';
 }
 if ($core->auth->check('delete,contentadmin',$core->blog->id))
 {
-	$combo_action[__('Delete')] = array(__('Delete') => 'delete');
+	$combo_action[__('delete')] = 'delete';
 }
 
 # --BEHAVIOR-- adminPagesActionsCombo
 $core->callBehavior('adminPagesActionsCombo',array(&$combo_action));
-
-
-/* Get posts
--------------------------------------------------------- */
-$post_list = new adminPageList($core);
-
-$params = new ArrayObject();
-$params['post_type'] = 'page';
-$params['no_content'] = true;
-
-$filterSet = new dcFilterSet('pages',$p_url);
-class monthComboFilter extends comboFilter {
-	public function applyFilter($params) {
-		$month=$this->values[0];
-		$params['post_month'] = substr($month,4,2);
-		$params['post_year'] = substr($month,0,4);
-	}
-}
-$filterSet
-	->addFilter(new comboFilter(
-		'users',__('Author'), __('Author'), 'user_id', $users_combo))
-	->addFilter(new comboFilter(
-		'post_status',__('Status'), __('Status'), 'post_status', $status_combo))
-	->addFilter(new comboFilter(
-		'lang',__('Lang'), __('Lang'), 'post_lang', $lang_combo))
-	->addFilter(new monthComboFilter(
-		'month',__('Month'),__('Month'), 'post_month', $dt_m_combo,array('singleval' => 1)))
-	->addFilter(new textFilter(
-		'search',__('Contains'),__('The page contains'), 'search',20,255));
-
-$core->callBehavior('adminPagesFilters',$filterSet);
-$filterSet->setExtra($post_list);
-
-$filterSet->setup($_GET,$_POST);
-
-# Get pages
-try {
-	$nfparams = $params->getArrayCopy();
-	$filtered = $filterSet->applyFilters($params);
-	$core->callBehavior('adminPostsParams',$params);
-	$posts = $core->blog->getPosts($params);
-	$counter = $core->blog->getPosts($params,true);
-	if ($filtered) {
-		$totalcounter = $core->blog->getPosts($nfparams,true);
-		$page_title = sprintf(__('Pages / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
-	} else {
-		$page_title = __('Pages');
-		$filters_info = '';
-	}
-	$post_list->setItems($posts,$counter->f(0));
-} catch (Exception $e) {
-	$core->error->add($e->getMessage());
-}
-
 
 /* Display
@@ -254,20 +173,16 @@
   //]]>
   </script>
-<?php
-echo $filterSet->header();
-?>
 </head>
 
 <body>
 <?php
+echo '<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; <span class="page-title">'.__('Pages').'</span></h2>'.
+'<p class="top-add"><a class="button add" href="'.$p_url.'&amp;act=page">'.__('New page').'</a></p>';
+
 if (!$core->error->flag())
 {
-	echo 
-	'<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; <span class="page-title">'.__('Pages').'</span></h2>'.
-	'<p class="top-add"><a class="button add" href="'.$p_url.'&amp;act=page">'.__('New page').'</a></p>';
-
-	$filterSet->display();
 	# Show pages
-	$post_list->display('<form action="posts_actions.php" method="post" id="form-entries">'.
+	$post_list->display($page,$nb_per_page,
+	'<form action="posts_actions.php" method="post" id="form-entries">'.
 	
 	'%s'.
@@ -279,11 +194,10 @@
 	form::combo('action',$combo_action).
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
+	form::hidden(array('post_type'),'page').
+	form::hidden(array('redir'),html::escapeHTML($_SERVER['REQUEST_URI'])).
 	$core->formNonce().
 	'</div>'.
-	'</form>'
-	);
-}
-
+	'</form>');
+}
 dcPage::helpBlock('pages');
 ?>
Index: plugins/simpleMenu/index.php
===================================================================
--- plugins/simpleMenu/index.php	(revision 776)
+++ plugins/simpleMenu/index.php	(revision 790)
@@ -405,7 +405,4 @@
 	</script>
 	<?php endif; ?>
-	<!--
-	<link rel="stylesheet" type="text/css" href="index.php?pf=simpleMenu/style.css" />
-	-->
 </head>
 
Index: plugins/tags/_admin.php
===================================================================
--- plugins/tags/_admin.php	(revision 782)
+++ plugins/tags/_admin.php	(revision 818)
@@ -131,27 +131,29 @@
 	public static function postsActionsHeaders()
 	{
-		$tag_url = $GLOBALS['core']->blog->url.$GLOBALS['core']->url->getURLFor('tag');
-		
-		$opts = $GLOBALS['core']->auth->getOptions();
-		$type = isset($opts['tag_list_format']) ? $opts['tag_list_format'] : 'more';
-		
-		return 
-		'<script type="text/javascript">'."\n".
-		"//<![CDATA[\n".
-		"metaEditor.prototype.meta_url = 'plugin.php?p=tags&m=tag_posts&amp;tag=';\n".
-		"metaEditor.prototype.meta_type = '".html::escapeJS($type)."';\n".
-		"metaEditor.prototype.text_confirm_remove = '".html::escapeJS(__('Are you sure you want to remove this %s?'))."';\n".
-		"metaEditor.prototype.text_add_meta = '".html::escapeJS(__('Add a %s to this entry'))."';\n".
-		"metaEditor.prototype.text_choose = '".html::escapeJS(__('Choose from list'))."';\n".
-		"metaEditor.prototype.text_all = '".html::escapeJS(__('all'))."';\n".
-		"metaEditor.prototype.text_separation = '".html::escapeJS(__('Enter tags separated by coma'))."';\n".
-		"dotclear.msg.tags_autocomplete = '".html::escapeJS(__('used in %e - frequency %p%'))."';\n".
-		"dotclear.msg.entry = '".html::escapeJS(__('entry'))."';\n".
-		"dotclear.msg.entries = '".html::escapeJS(__('entries'))."';\n".
-		"\n//]]>\n".
-		"</script>\n".
-		'<script type="text/javascript" src="index.php?pf=tags/js/posts_actions.js"></script>'.
-		dcPage::jqueryUI().
-		'<link rel="stylesheet" type="text/css" href="index.php?pf=tags/style.css" />';
+		if (($_POST['action'] == 'tags') || ($_POST['action'] == 'tags_remove')) {
+			$tag_url = $GLOBALS['core']->blog->url.$GLOBALS['core']->url->getURLFor('tag');
+
+			$opts = $GLOBALS['core']->auth->getOptions();
+			$type = isset($opts['tag_list_format']) ? $opts['tag_list_format'] : 'more';
+
+			return 
+			'<script type="text/javascript" src="index.php?pf=tags/js/jquery.autocomplete.js"></script>'.
+			'<script type="text/javascript" src="index.php?pf=tags/js/posts_actions.js"></script>'.
+			'<script type="text/javascript">'."\n".
+			"//<![CDATA[\n".
+			"metaEditor.prototype.meta_url = 'plugin.php?p=tags&m=tag_posts&amp;tag=';\n".
+			"metaEditor.prototype.meta_type = '".html::escapeJS($type)."';\n".
+			"metaEditor.prototype.text_confirm_remove = '".html::escapeJS(__('Are you sure you want to remove this %s?'))."';\n".
+			"metaEditor.prototype.text_add_meta = '".html::escapeJS(__('Add a %s to this entry'))."';\n".
+			"metaEditor.prototype.text_choose = '".html::escapeJS(__('Choose from list'))."';\n".
+			"metaEditor.prototype.text_all = '".html::escapeJS(__('all'))."';\n".
+			"metaEditor.prototype.text_separation = '".html::escapeJS(__('Enter tags separated by coma'))."';\n".
+			"dotclear.msg.tags_autocomplete = '".html::escapeJS(__('used in %e - frequency %p%'))."';\n".
+			"dotclear.msg.entry = '".html::escapeJS(__('entry'))."';\n".
+			"dotclear.msg.entries = '".html::escapeJS(__('entries'))."';\n".
+			"\n//]]>\n".
+			"</script>\n".
+			'<link rel="stylesheet" type="text/css" href="index.php?pf=tags/style.css" />';
+		}
 	}
 	
@@ -172,4 +174,5 @@
 			try
 			{
+
 				$meta =& $GLOBALS['core']->meta;
 				$tags = $meta->splitMetaValues($_POST['new_tags']);
Index: plugins/tags/_public.php
===================================================================
--- plugins/tags/_public.php	(revision 783)
+++ plugins/tags/_public.php	(revision 863)
@@ -44,5 +44,4 @@
 
 $core->addBehavior('templateBeforeBlock',array('behaviorsTags','templateBeforeBlock'));
-$core->addBehavior('tplSysIfConditions',array('behaviorsTags','tplSysIfConditions'));
 $core->addBehavior('publicBeforeDocument',array('behaviorsTags','addTplPath'));
 
@@ -55,8 +54,6 @@
 			return
 			"<?php\n".
-			"if (!isset(\$params['from'])) \$params['from']='';"."\n".
-			"if (!isset(\$params['sql'])) \$params['sql']='';"."\n".
-			"\$params['from'] .= ', '.\$core->prefix.'meta META ';\n".
-			"\$params['sql'] .= 'AND META.post_id = P.post_id ';\n".
+			"@\$params['from'] .= ', '.\$core->prefix.'meta META ';\n".
+			"@\$params['sql'] .= 'AND META.post_id = P.post_id ';\n".
 			"\$params['sql'] .= \"AND META.meta_type = 'tag' \";\n".
 			"\$params['sql'] .= \"AND META.meta_id = '".$core->con->escape($attr['tag'])."' \";\n".
@@ -66,24 +63,10 @@
 		{
 			return
-			'<?php if ($_ctx->exists("meta")) { '.
-				"if (!isset(\$params['from'])) \$params['from']='';"."\n".
-				"if (!isset(\$params['sql'])) \$params['sql']='';"."\n".
-				"\$params['from'] .= ', '.\$core->prefix.'meta META ';\n".
-				"\$params['sql'] .= 'AND META.post_id = P.post_id ';\n".
+			'<?php if ($_ctx->exists("meta") && ($_ctx->meta->meta_type == "tag")) { '.
+				"@\$params['from'] .= ', '.\$core->prefix.'meta META ';\n".
+				"@\$params['sql'] .= 'AND META.post_id = P.post_id ';\n".
 				"\$params['sql'] .= \"AND META.meta_type = 'tag' \";\n".
 				"\$params['sql'] .= \"AND META.meta_id = '\".\$core->con->escape(\$_ctx->meta->meta_id).\"' \";\n".
 			"} ?>\n";
-		}
-	}
-	
-	public static function tplIfConditions($tag, $attr,$content,$if)
-	{
-		if ($tag == 'Sys' && isset($attr['has_tag'])) {
-			$sign = '';
-			if (substr($attr['has_tag'],0,1) == '!') {
-				$sign = '!';
-				$attr['has_tag'] = substr($attr['has_tag'],1);
-			}
-			$if[] =  $sign."(\$core->tpl->tagExists('".addslashes($attr['has_tag'])."') )";
 		}
 	}
Index: plugins/tags/js/post.js
===================================================================
--- plugins/tags/js/post.js	(revision 756)
+++ plugins/tags/js/post.js	(revision 0)
@@ -1,9 +1,3 @@
 $(function() {
-	function split( val ) {
-		return val.split( /,\s*/ );
-	}
-	function extractLast(term) {
-		return split(term).pop();
-	}
 	$('#edit-entry').onetabload(function() {
 		var tags_edit = $('#tags-edit');
@@ -24,69 +18,42 @@
 		}
 		
-		$('#post_meta_input')
-			.bind( "keydown", function( event ) {
-		if ( event.keyCode === $.ui.keyCode.TAB &&
-				$( this ).data( "autocomplete" ).menu.active ) {
-			event.preventDefault();
-		}
-	})
-	.autocomplete({
-		minLength: 2,
-		delay: 1000,
-		source: function(request,response) {
-			$.ajax({
-				url: mEdit.service_uri,
-				data: {
-					'f': 'searchMeta',
-					'metaType': 'tag',
-					'q': extractLast(request.term)
-				},
-				success:function(data) {
-					results = [];
-					$(data).find('meta').each(function(){
-						var id = $(this).text();
-						var roundpercent = $(this).attr("roundpercent");
-						var count = $(this).attr("count");
-						console.log(id);
-						console.log(roundpercent);
-						console.log(count);
-						var label = id + ' (' +
-							dotclear.msg.tags_autocomplete.
-								replace('%p',roundpercent).
-								replace('%e',count + ' ' +
-								((count > 1) ?
-									dotclear.msg.entries :
-									dotclear.msg.entry
-								)) + ')';
-							console.log(label);
-						results.push({label:label,value:id});
-					});
-					response(results);
-				}
-			});
-		},
-		search: function() {
-			var term = extractLast( this.value );
-			if ( term.length < 2 ) {
-				return false;
+		$('#post_meta_input').autocomplete(mEdit.service_uri, {
+			extraParams: {
+				'f': 'searchMeta',
+				'metaType': 'tag'
+			},
+			delay: 1000,
+			multiple: true,
+			matchSubset: false,
+			matchContains: true,
+			parse: function(xml) { 
+				var results = [];
+				$(xml).find('meta').each(function(){
+					results[results.length] = {
+						data: {
+							"id": $(this).text(),
+							"count": $(this).attr("count"),
+							"percent":  $(this).attr("roundpercent")
+						},
+						result: $(this).text()
+					}; 
+				});
+				return results;
+			},
+			formatItem: function(tag) {
+				return tag.id + ' <em>(' +
+				dotclear.msg.tags_autocomplete.
+					replace('%p',tag.percent).
+					replace('%e',tag.count + ' ' +
+						(tag.count > 1 ?
+						dotclear.msg.entries :
+						dotclear.msg.entry)
+					) +
+				')</em>';
+			},
+			formatResult: function(tag) { 
+				return tag.result; 
 			}
-		},
-		focus: function() {
-			// prevent value inserted on focus
-			return false;
-		},
-		select: function( event, ui ) {
-			var terms = split( this.value );
-			// remove the current input
-			terms.pop();
-			// add the selected item
-			terms.push( ui.item.value );
-			// add placeholder to get the comma-and-space at the end
-			terms.push( "" );
-			this.value = terms.join( ", " );
-			return false;
-		}		
-	});
-
+		});
 	});
 });
Index: plugins/tags/js/posts_actions.js
===================================================================
--- plugins/tags/js/posts_actions.js	(revision 756)
+++ plugins/tags/js/posts_actions.js	(revision 0)
@@ -1,9 +1,3 @@
 $(function() {
-	function split( val ) {
-		return val.split( /,\s*/ );
-	}
-	function extractLast(term) {
-		return split(term).pop();
-	}
 	var tag_field = $('#new_tags');
 	
@@ -25,67 +19,41 @@
 	});
 	
-	$('#post_meta_input')
-	.bind( "keydown", function( event ) {
-		if ( event.keyCode === $.ui.keyCode.TAB &&
-				$( this ).data( "autocomplete" ).menu.active ) {
-			event.preventDefault();
+	$('#post_meta_input').autocomplete(mEdit.service_uri, {
+		extraParams: {
+			'f': 'searchMeta',
+			'metaType': 'tag'
+		},
+		delay: 1000,
+		multiple: true,
+		matchSubset: false,
+		matchContains: true,
+		parse: function(xml) { 
+			var results = [];
+			$(xml).find('meta').each(function(){
+				results[results.length] = {
+					data: {
+						"id": $(this).text(),
+						"count": $(this).attr("count"),
+						"percent":  $(this).attr("roundpercent")
+					},
+					result: $(this).text()
+				}; 
+			});
+			return results;
+		},
+		formatItem: function(tag) {
+			return tag.id + ' <em>(' +
+			dotclear.msg.tags_autocomplete.
+				replace('%p',tag.percent).
+				replace('%e',tag.count + ' ' +
+					(tag.count > 1 ?
+					dotclear.msg.entries :
+					dotclear.msg.entry)
+				) +
+			')</em>';
+		},
+		formatResult: function(tag) { 
+			return tag.result; 
 		}
-	})
-	.autocomplete({
-		minLength: 2,
-		delay: 1000,
-		source: function(request,response) {
-			$.ajax({
-				url: mEdit.service_uri,
-				data: {
-					'f': 'searchMeta',
-					'metaType': 'tag',
-					'q': extractLast(request.term)
-				},
-				success:function(data) {
-					results = [];
-					$(data).find('meta').each(function(){
-						var id = $(this).text();
-						var roundpercent = $(this).attr("roundpercent");
-						var count = $(this).attr("count");
-						console.log(id);
-						console.log(roundpercent);
-						console.log(count);
-						var label = id + ' (' +
-							dotclear.msg.tags_autocomplete.
-								replace('%p',roundpercent).
-								replace('%e',count + ' ' +
-								((count > 1) ?
-									dotclear.msg.entries :
-									dotclear.msg.entry
-								)) + ')';
-							console.log(label);
-						results.push({label:label,value:id});
-					});
-					response(results);
-				}
-			});
-		},
-		search: function() {
-			var term = extractLast( this.value );
-			if ( term.length < 2 ) {
-				return false;
-			}
-		},
-		focus: function() {
-			// prevent value inserted on focus
-			return false;
-		},
-		select: function( event, ui ) {
-			var terms = split( this.value );
-			// remove the current input
-			terms.pop();
-			// add the selected item
-			terms.push( ui.item.value );
-			// add placeholder to get the comma-and-space at the end
-			terms.push( "" );
-			this.value = terms.join( ", " );
-			return false;
-		}		
 	});
 });
Index: plugins/tags/tag_posts.php
===================================================================
--- plugins/tags/tag_posts.php	(revision 711)
+++ plugins/tags/tag_posts.php	(revision 793)
@@ -17,5 +17,5 @@
 
 
-$page = !empty($_GET['page']) ? $_GET['page'] : 1;
+$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
 $nb_per_page =  30;
 
Index: plugins/tags/tags.php
===================================================================
--- plugins/tags/tags.php	(revision 782)
+++ plugins/tags/tags.php	(revision 711)
@@ -43,11 +43,11 @@
 			$col = 1;
 		}
-		$cols[$col] .= '<tr class="tagLetter"><th scope="row" colspan="2"><span>'.$letter.'</span></th></tr>';
+		$cols[$col] .= '<tr class="tagLetter"><td colspan="2"><span>'.$letter.'</span></td></tr>';
 	}
 	
 	$cols[$col] .=
 	'<tr class="line">'.
-		'<th scope="row" class="maximal"><a href="'.$p_url.
-		'&amp;m=tag_posts&amp;tag='.rawurlencode($tags->meta_id).'">'.$tags->meta_id.'</a></th>'.
+		'<td class="maximal"><a href="'.$p_url.
+		'&amp;m=tag_posts&amp;tag='.rawurlencode($tags->meta_id).'">'.$tags->meta_id.'</a></td>'.
 		'<td class="nowrap"><strong>'.$tags->count.'</strong> '.
 		(($tags->count==1) ? __('entry') : __('entries')).'</td>'.
@@ -57,8 +57,5 @@
 }
 
-$table =
-'<div class="col"><table class="tags"><caption>'.
-__('Tags list').
-'</caption><tbody>%s</tbody></table></div>';
+$table = '<div class="col"><table class="tags">%s</table></div>';
 
 if ($cols[0])
Index: plugins/widgets/_widgets_functions.php
===================================================================
--- plugins/widgets/_widgets_functions.php	(revision 776)
+++ plugins/widgets/_widgets_functions.php	(revision 862)
@@ -250,5 +250,16 @@
 		$i = 0;
 		foreach ($feed->items as $item) {
-			$li = isset($item->link) ? '<a href="'.html::escapeHTML($item->link).'">'.$item->title.'</a>' : $item->title;
+			$title = isset($item->title) && strlen(trim($item->title)) ? $item->title : '';
+			$link = isset($item->link) && strlen(trim($item->link)) ? $item->link : '';
+			
+			if (!$link && !$title) {
+				continue;
+			}
+			
+			if (!$title) {
+				$title = substr($link,0,25).'...';
+			}
+			
+			$li = $link ? '<a href="'.html::escapeHTML($item->link).'">'.$title.'</a>' : $title;
 			$res .= ' <li>'.$li.'</li> ';
 			$i++;
Index: plugins/widgets/index.php
===================================================================
--- plugins/widgets/index.php	(revision 735)
+++ plugins/widgets/index.php	(revision 864)
@@ -325,5 +325,5 @@
 		form::checkbox(array($iname.'[_rem]'),'1',0).' '.__('Remove widget').
 		'</label></p>'.
-		'<div class="widgetSettings">'.$w->formSettings($iname,&$j).'</div>'.
+		'<div class="widgetSettings">'.$w->formSettings($iname,$j).'</div>'.
 		'</div>';
 		
